package org.rcisoft.bus.mixSelect.controller;

import io.swagger.annotations.ApiOperation;
import org.rcisoft.core.anno.CyOpeLogAnno;
import org.rcisoft.core.constant.CyMessCons;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.operlog.enums.CyLogTypeEnum;
import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.util.CyResultGenUtil;
import org.rcisoft.bus.mixSelect.entity.RequestDto;
import org.rcisoft.bus.mixSelect.entity.RequestInfromationDto;
import org.rcisoft.bus.mixSelect.service.MixSelectService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/mixSelect")
public class MixSelectController {

	@Autowired
	MixSelectService mixSelectService;

//	@PostMapping("/test")
//	public Object test(){
//		return "Hello";
//	}

	@PostMapping("/getListTotal")
	public CyResult getListTotal(@RequestBody RequestDto requestDto){
		return CyResultGenUtil.builder(new CyPersistModel(1),
			CyMessCons.MESSAGE_ALERT_SUCCESS,
			CyMessCons.MESSAGE_ALERT_ERROR,
			mixSelectService.getListTotal(requestDto));
	}

	@PostMapping("/getList")
	public CyResult getList(@RequestBody RequestDto requestDto){
		return CyResultGenUtil.builder(new CyPersistModel(1),
				CyMessCons.MESSAGE_ALERT_SUCCESS,
				CyMessCons.MESSAGE_ALERT_ERROR,
				mixSelectService.getList(requestDto));
	}

	@PostMapping("/getClickInformation")
	public CyResult getInformation(@RequestBody RequestInfromationDto requestInfromationDto){
		
		return CyResultGenUtil.builder(new CyPersistModel(1),
			CyMessCons.MESSAGE_ALERT_SUCCESS,
			CyMessCons.MESSAGE_ALERT_ERROR,
			mixSelectService.getInformation(requestInfromationDto));
	}

	@PostMapping("/getClickInformationPageNum")
	public CyResult getClickInformationPageNum(@RequestBody RequestInfromationDto requestInfromationDto){
		return CyResultGenUtil.builder(new CyPersistModel(1),
			CyMessCons.MESSAGE_ALERT_SUCCESS,
			CyMessCons.MESSAGE_ALERT_ERROR,
			mixSelectService.getClickInformationPageNum(requestInfromationDto));
	}

//	@PostMapping("/postTest")
//	public String postTest(@RequestBody Test test){
//		System.out.println(test.toString());
//		return "hello" + test.toString();
//	}

	@CyOpeLogAnno(title = "system-DemoData1管理-查询标签aaa", businessType = CyLogTypeEnum.OTHER)
	@ApiOperation(value ="查询标签aaa",notes = "查询标签aaa")
	@GetMapping("/searchAaa")
	public CyResult searchAaa(){
		return CyResultGenUtil.builder(new CyPersistModel(1),
				CyMessCons.MESSAGE_ALERT_SUCCESS,
				CyMessCons.MESSAGE_ALERT_ERROR,
				mixSelectService.searchAaa());
	}
	@CyOpeLogAnno(title = "system-DemoData1管理-查询标签ccc", businessType = CyLogTypeEnum.OTHER)
	@ApiOperation(value ="查询标签ccc",notes = "查询标签ccc")
	@GetMapping("/searchCcc")
	public CyResult searchCcc(){
		return CyResultGenUtil.builder(new CyPersistModel(1),
				CyMessCons.MESSAGE_ALERT_SUCCESS,
				CyMessCons.MESSAGE_ALERT_ERROR,
				mixSelectService.searchCcc());
	}
	@CyOpeLogAnno(title = "system-DemoData1管理-查询标签cccc", businessType = CyLogTypeEnum.OTHER)
	@ApiOperation(value ="查询标签cccc",notes = "查询标签cccc")
	@GetMapping("/searchCccc")
	public CyResult searchCccc(){
		return CyResultGenUtil.builder(new CyPersistModel(1),
				CyMessCons.MESSAGE_ALERT_SUCCESS,
				CyMessCons.MESSAGE_ALERT_ERROR,
				mixSelectService.searchCccc());
	}
	@CyOpeLogAnno(title = "system-DemoData1管理-查询标签eee", businessType = CyLogTypeEnum.OTHER)
	@ApiOperation(value ="查询标签eee",notes = "查询标签eee")
	@GetMapping("/searchEee")
	public CyResult searchEee(){
		return CyResultGenUtil.builder(new CyPersistModel(1),
				CyMessCons.MESSAGE_ALERT_SUCCESS,
				CyMessCons.MESSAGE_ALERT_ERROR,
				mixSelectService.searchEee());
	}

	@CyOpeLogAnno(title = "system-DemoData1管理-查询标签bbb", businessType = CyLogTypeEnum.OTHER)
	@ApiOperation(value ="查询标签bbb",notes = "查询标签bbb")
	@GetMapping("/searchBbb")
	public CyResult searchBbb(){
		return CyResultGenUtil.builder(new CyPersistModel(1),
				CyMessCons.MESSAGE_ALERT_SUCCESS,
				CyMessCons.MESSAGE_ALERT_ERROR,
				mixSelectService.searchBbb());
	}


	@CyOpeLogAnno(title = "system-DemoData1管理-查询标签Ddd", businessType = CyLogTypeEnum.OTHER)
	@ApiOperation(value ="查询标签Ddd",notes = "查询标签Ddd")
	@GetMapping("/searchDdd")
	public CyResult searchDdd(){
		return CyResultGenUtil.builder(new CyPersistModel(1),
				CyMessCons.MESSAGE_ALERT_SUCCESS,
				CyMessCons.MESSAGE_ALERT_ERROR,
				mixSelectService.searchDdd());
	}

	@CyOpeLogAnno(title = "system-DemoData1管理-查询标签Dddd", businessType = CyLogTypeEnum.OTHER)
	@ApiOperation(value ="查询标签eee",notes = "查询标签Dddd")
	@GetMapping("/searchDddd")
	public CyResult searchDddd(){
		return CyResultGenUtil.builder(new CyPersistModel(1),
				CyMessCons.MESSAGE_ALERT_SUCCESS,
				CyMessCons.MESSAGE_ALERT_ERROR,
				mixSelectService.searchDddd());
	}

	@CyOpeLogAnno(title = "system-DemoData1管理-查询标签nqy", businessType = CyLogTypeEnum.OTHER)
	@ApiOperation(value ="查询标签nqy",notes = "查询标签nqy")
	@GetMapping("/searchNqy")
	public CyResult searchNqy(){
		return CyResultGenUtil.builder(new CyPersistModel(1),
				CyMessCons.MESSAGE_ALERT_SUCCESS,
				CyMessCons.MESSAGE_ALERT_ERROR,
				mixSelectService.searchNqy());
	}
	@CyOpeLogAnno(title = "system-DemoData1管理-查询标签khqf", businessType = CyLogTypeEnum.OTHER)
	@ApiOperation(value ="查询标签khqf",notes = "查询标签khqf")
	@GetMapping("/searchKhqf")
	public CyResult searchKhqf(){
		return CyResultGenUtil.builder(new CyPersistModel(1),
				CyMessCons.MESSAGE_ALERT_SUCCESS,
				CyMessCons.MESSAGE_ALERT_ERROR,
				mixSelectService.searchKhqf());
	}
	@CyOpeLogAnno(title = "system-DemoData1管理-查询标签jlpm", businessType = CyLogTypeEnum.OTHER)
	@ApiOperation(value ="查询标签jlpm",notes = "查询标签jlpm")
	@GetMapping("/searchJlpm")
	public CyResult searchJlpm(){
		return CyResultGenUtil.builder(new CyPersistModel(1),
				CyMessCons.MESSAGE_ALERT_SUCCESS,
				CyMessCons.MESSAGE_ALERT_ERROR,
				mixSelectService.searchJlpm());
	}

}
