package org.rcisoft.bus.mixSelect.service.impl;

import org.rcisoft.bus.mixSelect.entity.DemoData1;
import org.rcisoft.bus.mixSelect.dao.MixSelectMapper;
import org.rcisoft.bus.mixSelect.entity.Infromation;
import org.rcisoft.bus.mixSelect.entity.RequestDto;
import org.rcisoft.bus.mixSelect.entity.RequestInfromationDto;
import org.rcisoft.bus.mixSelect.entity.User;
import org.rcisoft.bus.mixSelect.service.MixSelectService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class MixSelectServiceImpl implements MixSelectService {

	@Autowired
	MixSelectMapper mixSelectMapper;


	@Override
	public List<User> getList(RequestDto requestDto) {

		//判断查询条件是否为全空
		boolean conditionIsNull = requestDto.isGgg() ||
			requestDto.isJjj() ||
			requestDto.isKkk() ||
			requestDto.isHhh() ||
			requestDto.isFff() ||
			requestDto.isIii();

		//没有选择默认选一个
		if (!conditionIsNull){
			requestDto.setFff(true);
		}


		//查询月份，不知道有啥用
		List<String> monthsList = mixSelectMapper.getMonths();

		String months = monthsList.stream()
			// 将每个月份拼接成形如 "[yyyyMM]" 的字符串
			.map(month -> "[" + month + "]")
			// 使用逗号连接每个月份字符串
			.collect(Collectors.joining(","));

		List<Map> listhhh = null;
		List<Map> listiii = null;
		List<Map> listkkk = null;
		List<Map> listfff = null;
		List<Map> listjjj = null;
		List<Map> listggg = null;
		//查询数据库
		//判断需要查询哪一个

		//页数
		Integer pageNo = requestDto.getPageNo();
		//每页大小
		Integer pageSize = requestDto.getPageSize();


		//默认查三个
		//定义变量进行存储
		int count = 0;
		boolean[] flag = new boolean[]{false,false,false,false,false,false};
		if (requestDto.isFff() && count < 3) {
			listfff = mixSelectMapper.getListfff(requestDto, months, pageNo, pageSize);
			count++;
			flag[0] = true;
		}
		if (requestDto.isGgg() && count < 3) {
			listggg = mixSelectMapper.getListggg(requestDto, months, pageNo, pageSize);
			count++;
			flag[1] = true;
		}
		if (requestDto.isHhh() && count < 3) {
			listhhh = mixSelectMapper.getListhhh(requestDto, months, pageNo, pageSize);
			count++;
			flag[2] = true;
		}
		if (requestDto.isIii() && count < 3) {
			listiii = mixSelectMapper.getListiii(requestDto, months, pageNo, pageSize);
			count++;
			flag[3] = true;
		}
		if (requestDto.isJjj() && count < 3) {
			listjjj = mixSelectMapper.getListjjj(requestDto, months, pageNo, pageSize);
			count++;
			flag[4] = true;
		}
		if (requestDto.isKkk() && count < 3) {
			listkkk = mixSelectMapper.getListkkk(requestDto, months, pageNo, pageSize);
			count++;
			flag[5] = true;
		}
		int size = 0;
		//获得返回数据长度
		if (listhhh != null) {
			size = listhhh.size();
		} else if (listiii != null) {
			size = listiii.size();
		} else if (listkkk != null) {
			size = listkkk.size();
		} else if (listfff != null) {
			size = listfff.size();
		} else if (listggg != null) {
			size = listggg.size();
		}else {
			size = listjjj.size();
		}

		//获取对应关系
		Map<String, User> map = new HashMap();

		//创建填充数据
		List<User> resList = new ArrayList<>();

		//获取日期参数
		List<String> aaa = requestDto.getAaa();

		//判断是否传入日期参数，如果没传入设置默认值
		if (aaa == null || aaa.size() == 0){
			aaa = monthsList;
		}

		//填充返回数据
		for (int i = 0; i < size; i++) {
			//填充三种数据
			if (listhhh != null) {
				Map listMap = listhhh.get(i);
				//获取ccc(用户名)
				Integer ccc = (Integer) listMap.get("ccc");

				//删除"ccc"
				listMap.remove("ccc");

				User user = map.getOrDefault(ccc.toString(), null);
				//判断该用户是否创建过
				if (user == null) {
					//创建对象加入到list结果中
					user = new User(ccc.toString(), aaa, flag);
					resList.add(user);
					map.put(ccc.toString(),user);
				}
				//获取到user中的Data数据
				List<Infromation> data = user.getData();

				//获取月份对照集合
				Map<String, Integer> month = user.getMap();

				//set为键值对对象
				Set set = listMap.entrySet();

				for (Object o : set) {

					//强制转化为Entry对象
					Map.Entry<String, String> entry = (Map.Entry<String, String>) o;

					//获取到数据库中对应的月份
					String target = listMap.getOrDefault(entry.getKey(), null).toString();
					//不为空添加数据
					if (target != null) {
						//获取月份对应的下标
						Integer index = month.get(entry.getKey());
						//获取信息
						Infromation infromation = data.get(index);

						//原则上调用toString方法能解决，但是JIT自动优化了，只能使用上转型
						Object value = entry.getValue();
						infromation.setHhh(value.toString());
					}
				}
			}
			if (listiii != null) {
				//填充三种数据
				if (listiii != null) {
					Map listMap = listiii.get(i);
					//获取ccc(用户名)
					Integer ccc = (Integer) listMap.get("ccc");

					//删除"ccc"
					listMap.remove("ccc");

					User user = map.getOrDefault(ccc.toString(), null);
					//判断该用户是否创建过
					if (user == null) {
						//创建对象加入到list结果中
						user = new User(ccc.toString(), aaa, flag);
						resList.add(user);
						map.put(ccc.toString(),user);
					}
					//获取到user中的Data数据
					List<Infromation> data = user.getData();

					//获取月份对照集合
					Map<String, Integer> month = user.getMap();

					//set为键值对对象
					Set set = listMap.entrySet();

					for (Object o : set) {

						//强制转化为Entry对象
						Map.Entry<String, String> entry = (Map.Entry<String, String>) o;

						//获取到数据库中对应的月份
						String target = listMap.getOrDefault(entry.getKey(), null).toString();
						//不为空添加数据
						if (target != null) {
							//获取月份对应的下标
							Integer index = month.get(entry.getKey());
							//获取信息
							Infromation infromation = data.get(index);

							//原则上调用toString方法能解决，但是JIT自动优化了，只能使用上转型
							Object value = entry.getValue();
							infromation.setIii(value.toString());
						}
					}
				}
			}
			if (listkkk != null) {
				Map listMap = listkkk.get(i);
				//获取ccc(用户名)
				Integer ccc = (Integer) listMap.get("ccc");

				//删除"ccc"
				listMap.remove("ccc");

				User user = map.getOrDefault(ccc.toString(), null);
				//判断该用户是否创建过
				if (user == null) {
					//创建对象加入到list结果中
					user = new User(ccc.toString(), aaa, flag);
					resList.add(user);
					map.put(ccc.toString(),user);
				}
				//获取到user中的Data数据
				List<Infromation> data = user.getData();

				//获取月份对照集合
				Map<String, Integer> month = user.getMap();

				//set为键值对对象
				Set set = listMap.entrySet();

				for (Object o : set) {

					//强制转化为Entry对象
					Map.Entry<String, String> entry = (Map.Entry<String, String>) o;

					//获取到数据库中对应的月份
					String target = listMap.getOrDefault(entry.getKey(), null).toString();
					//不为空添加数据
					if (target != null) {
						//获取月份对应的下标
						Integer index = month.get(entry.getKey());
						//获取信息
						Infromation infromation = data.get(index);

						//原则上调用toString方法能解决，但是JIT自动优化了，只能使用上转型
						Object value = entry.getValue();
						infromation.setKkk(value.toString());
					}
				}
			}
			if (listfff != null) {
				Map listMap = listfff.get(i);
				//获取ccc(用户名)
				Integer ccc = (Integer) listMap.get("ccc");

				//删除"ccc"
				listMap.remove("ccc");

				User user = map.getOrDefault(ccc.toString(), null);
				//判断该用户是否创建过
				if (user == null) {
					//创建对象加入到list结果中
					user = new User(ccc.toString(), aaa, flag);
					resList.add(user);
					map.put(ccc.toString(),user);
				}
				//获取到user中的Data数据
				List<Infromation> data = user.getData();

				//获取月份对照集合
				Map<String, Integer> month = user.getMap();

				//set为键值对对象
				Set set = listMap.entrySet();

				for (Object o : set) {

					//强制转化为Entry对象
					Map.Entry<String, String> entry = (Map.Entry<String, String>) o;

					//获取到数据库中对应的月份
					String target = listMap.getOrDefault(entry.getKey(), null).toString();
					//不为空添加数据
					if (target != null) {
						//获取月份对应的下标
						Integer index = month.get(entry.getKey());
						//获取信息
						Infromation infromation = data.get(index);

						//原则上调用toString方法能解决，但是JIT自动优化了，只能使用上转型
						Object value = entry.getValue();
						infromation.setFff(value.toString());
					}
				}
			}
			if (listggg != null) {
				Map listMap = listggg.get(i);
				//获取ccc(用户名)
				Integer ccc = (Integer) listMap.get("ccc");

				//删除"ccc"
				listMap.remove("ccc");

				User user = map.getOrDefault(ccc.toString(), null);
				//判断该用户是否创建过
				if (user == null) {
					//创建对象加入到list结果中
					user = new User(ccc.toString(), aaa, flag);
					resList.add(user);
					map.put(ccc.toString(),user);
				}
				//获取到user中的Data数据
				List<Infromation> data = user.getData();

				//获取月份对照集合
				Map<String, Integer> month = user.getMap();

				//set为键值对对象
				Set set = listMap.entrySet();

				for (Object o : set) {

					//强制转化为Entry对象
					Map.Entry<String, String> entry = (Map.Entry<String, String>) o;

					//获取到数据库中对应的月份
					String target = listMap.getOrDefault(entry.getKey(), null).toString();
					//不为空添加数据
					if (target != null) {
						//获取月份对应的下标
						Integer index = month.get(entry.getKey());
						//获取信息
						Infromation infromation = data.get(index);

						//原则上调用toString方法能解决，但是JIT自动优化了，只能使用上转型
						Object value = entry.getValue();
						infromation.setGgg(value.toString());
					}
				}
			}
			if (listjjj != null) {
				Map listMap = listjjj.get(i);
				//获取ccc(用户名)
				Integer ccc = (Integer) listMap.get("ccc");

				//删除"ccc"
				listMap.remove("ccc");

				User user = map.getOrDefault(ccc.toString(), null);
				//判断该用户是否创建过
				if (user == null) {
					//创建对象加入到list结果中
					user = new User(ccc.toString(), aaa, flag);
					resList.add(user);
					map.put(ccc.toString(),user);
				}
				//获取到user中的Data数据
				List<Infromation> data = user.getData();

				//获取月份对照集合
				Map<String, Integer> month = user.getMap();

				//set为键值对对象
				Set set = listMap.entrySet();

				for (Object o : set) {

					//强制转化为Entry对象
					Map.Entry<String, String> entry = (Map.Entry<String, String>) o;

					//获取到数据库中对应的月份
					String target = listMap.getOrDefault(entry.getKey(), null).toString();
					//不为空添加数据
					if (target != null) {
						//获取月份对应的下标
						Integer index = month.get(entry.getKey());
						//获取信息
						Infromation infromation = data.get(index);

						//原则上调用toString方法能解决，但是JIT自动优化了，只能使用上转型
						Object value = entry.getValue();
						infromation.setJjj(value.toString());
					}
				}
			}
		}
		return resList;
	}

	@Override
	public List<DemoData1> getInformation(RequestInfromationDto requestInfromationDto) {

		//设置查询值
		String key = requestInfromationDto.getClickKey();
		RequestInfromationDto.cleanAndBuild(requestInfromationDto,key);

		//单独查询
		List<DemoData1> data = mixSelectMapper.getInformation(requestInfromationDto);

		return data;
	}

	@Override
	public Integer getListTotal(RequestDto requestDto) {
		//查询月份，不知道有啥用
		List<String> monthsList = mixSelectMapper.getMonths();

		String months = monthsList.stream()
			// 将每个月份拼接成形如 "[yyyyMM]" 的字符串
			.map(month -> "[" + month + "]")
			// 使用逗号连接每个月份字符串
			.collect(Collectors.joining(","));


		List<Map> temp = null;
		//获得返回数据长度
		if (requestDto.isHhh()) {
			temp = mixSelectMapper.getListhhhTotal(requestDto, months);
			return temp.size();
		} else if (requestDto.isIii()) {
			temp = mixSelectMapper.getListiiiTotal(requestDto, months);
			return temp.size();
		} else if (requestDto.isKkk()) {
			temp = mixSelectMapper.getListkkkTotal(requestDto, months);
			return temp.size();
		} else if (requestDto.isFff()) {
			temp = mixSelectMapper.getListfffTotal(requestDto, months);
			return temp.size();
		} else if (requestDto.isGgg()) {
			temp = mixSelectMapper.getListgggTotal(requestDto, months);
			return temp.size();
		}else {
			temp = mixSelectMapper.getListjjjTotal(requestDto, months);
			return temp.size();
		}
	}

	@Override
	public Integer getClickInformationPageNum(RequestInfromationDto requestInfromationDto) {
		//设置查询值
		String key = requestInfromationDto.getClickKey();
		RequestInfromationDto.cleanAndBuild(requestInfromationDto,key);

		//单独查询
		Integer data = mixSelectMapper.getClickInformationPageNum(requestInfromationDto);

		return data;
	}

	/**返回下拉数据*/
	@Override
	public List<DemoData1> searchAaa() {
		return mixSelectMapper.searchAaa();
	}

	@Override
	public List<DemoData1> searchCcc() {
		return mixSelectMapper.searchCcc();
	}

	@Override
	public List<DemoData1> searchCccc() {
		return mixSelectMapper.searchCccc();
	}

	@Override
	public List<DemoData1> searchEee() {
		return mixSelectMapper.searchEee();
	}

	@Override
	public List<DemoData1> searchBbb() {
		return mixSelectMapper.searchBbb();
	}

	@Override
	public List<DemoData1> searchDddd() {
		return mixSelectMapper.searchDddd();
	}

	@Override
	public List<DemoData1> searchDdd() {
		return mixSelectMapper.searchDdd();
	}

	@Override
	public List<DemoData1> searchNqy() {
		return mixSelectMapper.searchNqy();
	}

	@Override
	public List<DemoData1> searchKhqf() {
		return mixSelectMapper.searchKhqf();
	}

	@Override
	public List<DemoData1> searchJlpm() {
		return mixSelectMapper.searchJlpm();
	}


}
